## dolfinx-mpc 0.5.0.post0

=== cpp/CMakeLists.txt ===
#------------------------------------------------------------------------------
# Top level CMakeLists.txt file for DOLFIN
cmake_minimum_required(VERSION 3.16)

#------------------------------------------------------------------------------
# Set project name and version number
project(DOLFINX_MPC VERSION "0.5.1.0")

#------------------------------------------------------------------------------
# Set CMake options, see `cmake --help-policy CMP000x`

cmake_policy(VERSION 3.10)
if (POLICY CMP0074)
  cmake_policy(SET CMP0074 NEW)
endif()
if (POLICY CMP0075)
  cmake_policy(SET CMP0075 NEW)
endif()

#------------------------------------------------------------------------------
# Use C++17
set(CMAKE_CXX_STANDARD 20)

# Require C++17
set(CMAKE_CXX_STANDARD_REQUIRED ON)

# Do not enable compler-specific extensions
set(CMAKE_CXX_EXTENSIONS OFF)

#------------------------------------------------------------------------------
# General configuration
# Make sure CMake uses the correct DOLFINConfig.cmake for tests and demos
set(CMAKE_PREFIX_PATH ${CMAKE_PREFIX_PATH} ${CMAKE_CURRENT_BINARY_DIR}/dolfinx_mpc)

#------------------------------------------------------------------------------
# configurable options for how we want to build

include(FeatureSummary)

option(BUILD_SHARED_LIBS "Build DOLFINX_MPC with shared libraries." ON)
add_feature_info(BUILD_SHARED_LIBS BUILD_SHARED_LIBS "Build DOLFINX_MPC with shared libraries.")

option(CMAKE_INSTALL_RPATH_USE_LINK_PATH "Add paths to linker search and installed rpath." ON)
add_feature_info(CMAKE_INSTALL_RPATH_USE_LINK_PATH CMAKE_INSTALL_RPATH_USE_LINK_PATH "Add paths to linker search and installed rpath.")



# Check for required package UFC (part of ffcx)
MESSAGE(STATUS "Asking Python module FFCX for location of UFC...")
  find_package(PythonInterp 3 REQUIRED)
  execute_process(
	  COMMAND ${PYTHON_EXECUTABLE} -c "import ffcx.codegeneration, sys; sys.stdout.write(ffcx.codegeneration.get_include_path())"
    OUTPUT_VARIABLE UFC_INCLUDE_DIR
    )

  if (UFC_INCLUDE_DIR)
    set(UFC_INCLUDE_DIRS ${UFC_INCLUDE_DIR} CACHE STRING "Where to find ufc.h and ufc_geometry.h")

    execute_process(
      COMMAND ${PYTHON_EXECUTABLE} -c "import ffcx, sys; sys.stdout.write(ffcx.__version__)"
      OUTPUT_VARIABLE UFC_VERSION
      )

    if (UFC_FIND_VERSION)
      # Check if version found is >= required version
      if (NOT "${UFC_VERSION}" VERSION_LESS "${UFC_FIND_VERSION}")
        set(UFC_VERSION_OK TRUE)
      endif()
    else()
      # No specific version requested
      set(UFC_VERSION_OK TRUE)
    endif()
  endif()

  execute_process(
    COMMAND ${PYTHON_EXECUTABLE} -c "import ffcx.codegeneration, sys; sys.stdout.write(ffcx.codegeneration.get_signature())"
    OUTPUT_VARIABLE UFC_SIGNATURE
  )

mark_as_advanced(UFC_VERSION UFC_INCLUDE_DIRS UFC_SIGNATURE UFC_VERSION_OK)
# Standard package handling
find_package_handle_standard_args(UFC
                                  "UFC could not be found."
                                  UFC_INCLUDE_DIRS
                                  UFC_VERSION
                                  UFC_VERSION_OK
                                  UFC_SIGNATURE)
set_package_properties(UFC PROPERTIES TYPE REQUIRED
  DESCRIPTION "Unified language for form-compilers (part of FFC-X)"
  URL "https://github.com/fenics/ffcx")

# Check for required package DOLFINX
find_package(DOLFINX 0.5.1 REQUIRED)
set_package_properties(DOLFINX PROPERTIES TYPE REQUIRED
    DESCRIPTION "New generation Dynamic Object-oriented Library for - FINite element computation"
    URL "https://github.com/FEniCS/dolfinx"
    PURPOSE "Main dependency of library")

find_package(Basix 0.5.0 REQUIRED)
set_package_properties(basix PROPERTIES TYPE REQUIRED
      DESCRIPTION "FEniCS tabulation library"
      URL "https://github.com/fenics/basix")


# MPI and PETSC

# MPI
find_package(MPI 3 REQUIRED)

# Check for PETSc
find_package(PkgConfig REQUIRED)
set(ENV{PKG_CONFIG_PATH} "$ENV{PETSC_DIR}/$ENV{PETSC_ARCH}/lib/pkgconfig:$ENV{PETSC_DIR}/lib/pkgconfig:$ENV{PKG_CONFIG_PATH}")
pkg_search_module(PETSC REQUIRED IMPORTED_TARGET PETSc>=3.15 petsc>=3.15)

# Check if PETSc build uses real or complex scalars (this is configured
# in DOLFINxConfig.cmake.in)
include(CheckSymbolExists)
set(CMAKE_REQUIRED_INCLUDES ${PETSC_INCLUDE_DIRS})
check_symbol_exists(PETSC_USE_COMPLEX petscsystypes.h HAVE_PETSC_SCALAR_COMPLEX)

# Setting for FeatureSummary
if(PETSC_FOUND)
  set_property(GLOBAL APPEND PROPERTY PACKAGES_FOUND PETSc)
else()
  set_property(GLOBAL APPEND PROPERTY PACKAGES_NOT_FOUND PETSc)
endif()
set_package_properties(PETSc PROPERTIES TYPE REQUIRED
  DESCRIPTION "Portable, Extensible Toolkit for Scientific Computation (PETSc)"
  URL "https://www.mcs.anl.gov/petsc/"
  PURPOSE "PETSc linear algebra backend")

feature_summary(WHAT ALL)


# Installation of DOLFIN_MPC library

add_library(dolfinx_mpc "")  # The "" is needed for older CMake. Remove later.

target_link_libraries(dolfinx_mpc PUBLIC MPI::MPI_CXX)
target_link_libraries(dolfinx_mpc PUBLIC PkgConfig::PETSC)

# Basix
target_link_libraries(dolfinx_mpc PUBLIC Basix::basix)



if (UFC_FOUND)
    target_include_directories(dolfinx_mpc PRIVATE ${UFC_INCLUDE_DIRS})
endif()
target_link_libraries(dolfinx_mpc PUBLIC dolfinx)


# Delcare the library (target)

#------------------------------------------------------------------------------
include(GNUInstallDirs)

#------------------------------------------------------------------------------

install(FILES dolfinx_mpc.h  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/dolfinx_mpc COMPONENT Development)

install(FILES assemble_utils.h mpi_utils.h ContactConstraint.h utils.h MultiPointConstraint.h SlipConstraint.h PeriodicConstraint.h assemble_matrix.h assemble_vector.h lifting.h mpc_helpers.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/dolfinx_mpc COMPONENT Development)
# Add source files to the target
target_sources(dolfinx_mpc PRIVATE
${CMAKE_CURRENT_SOURCE_DIR}/SlipConstraint.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/ContactConstraint.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/PeriodicConstraint.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/utils.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/assemble_matrix.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/assemble_vector.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/mpc_helpers.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/assemble_utils.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/mpi_utils.cpp
  )

# Set target include location (for build and installed)
target_include_directories(dolfinx_mpc PUBLIC
                           $<INSTALL_INTERFACE:include>
                           "$<BUILD_INTERFACE:${DOLFINX_MPC_SOURCE_DIR};${DOLFINX_MPC_SOURCE_DIR}/dolfinx_mpc>")

# Set target properties
set_target_properties(dolfinx_mpc PROPERTIES
  VERSION ${DOLFINX_MPC_VERSION}
  SOVERSION ${DOLFINX_MPC_VERSION_MAJOR}.${DOLFINX_MPC_VERSION_MINOR})


# Add version to definitions (public)
target_compile_definitions(dolfinx_mpc PUBLIC DOLFINX_MPC_VERSION="${DOLFINX_MPC_VERSION}")


#------------------------------------------------------------------------------
# Install dolfinx library and header files
install(TARGETS dolfinx_mpc
  EXPORT DOLFINX_MPCTargets
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR} COMPONENT RuntimeExecutables
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT RuntimeLibraries
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT Development
  )

# Generate DOLFINTargets.cmake
install(EXPORT DOLFINX_MPCTargets DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/dolfinx_mpc)

include(CMakePackageConfigHelpers)

configure_package_config_file(${DOLFINX_MPC_SOURCE_DIR}/DOLFINX_MPCConfig.cmake.in
${CMAKE_BINARY_DIR}/dolfinx_mpc/DOLFINX_MPCConfig.cmake
INSTALL_DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/dolfinx_mpc)

# Install CMake helper files
install(
  FILES
  ${CMAKE_BINARY_DIR}/dolfinx_mpc/DOLFINX_MPCConfig.cmake
  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/dolfinx_mpc
  COMPONENT Development)

#------------------------------------------------------------------------------

=== python/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

PROJECT(dolfinx_mpc_pybind11)

find_package(pybind11 REQUIRED CONFIG HINTS ${PYBIND11_DIR} ${PYBIND11_ROOT}
  $ENV{PYBIND11_DIR} $ENV{PYBIND11_ROOT})

find_package(DOLFINX_MPC REQUIRED)
find_package(Basix REQUIRED)

# Set C++ standard before finding pybind11
set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

# Create the binding library
pybind11_add_module(cpp SHARED
   dolfinx_mpc/mpc.cpp
   dolfinx_mpc/dolfinx_mpc.cpp)

target_link_libraries(cpp PRIVATE pybind11::module dolfinx_mpc)
target_link_libraries(cpp PUBLIC dolfinx)
target_include_directories(cpp PUBLIC dolfinx)

# Get python include-dirs
execute_process(
  COMMAND ${Python3_EXECUTABLE} -c "import dolfinx.wrappers, sys; sys.stdout.write(str(dolfinx.wrappers.get_include_path()))"
  OUTPUT_VARIABLE DOLFINX_PY_DIR
  RESULT_VARIABLE DOLFINX_PY_COMMAND_RESULT OUTPUT_STRIP_TRAILING_WHITESPACE)

if (DOLFINX_PY_DIR)
  message(STATUS "Adding ${DOLFINX_PY_DIR} to include directories")
  target_include_directories(cpp PRIVATE ${DOLFINX_PY_DIR})
endif()

# Add strict compiler flags
include(CheckCXXCompilerFlag)
CHECK_CXX_COMPILER_FLAG("-Wall -Werror -pedantic" HAVE_PEDANTIC)
if (HAVE_PEDANTIC)
  target_compile_options(cpp PRIVATE -Wall;-Werror;-pedantic)
endif()


# Add to CMake search path
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR})

# Add DOLFINX libraries and other config
find_package(DOLFINX REQUIRED)
if (DOLFINX_FOUND)
   target_include_directories(cpp PRIVATE ${DOLFINX_INCLUDE_DIR})

# Find petsc4py through python
execute_process(
  COMMAND ${PYTHON_EXECUTABLE} -c "import petsc4py; print(petsc4py.get_include())"
  OUTPUT_VARIABLE PETSC4PY_INCLUDE_DIR
  RESULT_VARIABLE PETSC4PY_NOT_FOUND
  ERROR_QUIET
  OUTPUT_STRIP_TRAILING_WHITESPACE
  )
target_include_directories(cpp PRIVATE ${PETSC4PY_INCLUDE_DIR})

endif()

=== debian/changelog ===
dolfinx-mpc (0.5.0.post0-2) unstable; urgency=medium

  * debian patch fix_mesh_py3.11.patch repairs finalisation of mpc
    following py3.11 mesh patch to dolfinx
  * build for all supported python versions, test only on default
    python (ffcx JIT files may clash between different python
    versions. Delete ~/.cache/fenics to clear the cache if necessary)

 -- Drew Parsons <dparsons@debian.org>  Mon, 09 Jan 2023 01:30:35 +0100

dolfinx-mpc (0.5.0.post0-1) unstable; urgency=medium

  * Initial release. (Closes: #1026079)
  * add debian patches
    - cmake_dolfinx_upper_version.patch imposes upper version on
      dolfinx and basix dependencies (enabling use of newer patch
      releases) and specifies dolfinx=0.5.2 (since upstream PR#2358 is
      not yet finished for handling dolfinx version ranges)
    - cmake_config_libdir.patch installs cmake config files to
      arch-dependent location
    - tests_no_numba.patch eliminates numba from python tests
      (numba is currently not available)
    - cmake_no_runpath.patch switches off RUNPATH in shared library
      and python extensions (.so)
  * Disable pybuild tests when building python modules. Unittest
    discover triggers a missing numba error, and is not used anyway.
  * tests are currently only run for python3.10.
    See https://github.com/FEniCS/dolfinx/issues/2423
  * use cache dir in local build dir to run tests
  * Build-Depends: pybuild-plugin-pyproject even though no
    pyproject.toml file is present. pyproject builds are now better
    and simpler than distutils (which runs the internal cmake
    configuration twice, once for the build rule, and again for the
    install rule).

 -- Drew Parsons <dparsons@debian.org>  Tue, 03 Jan 2023 19:15:58 +0100

=== debian/control ===
Source: dolfinx-mpc
Section: libs
Priority: optional
Maintainer: Drew Parsons <dparsons@debian.org>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 libbasix-dev (>= 0.5.0~), python3-basix,
 libdolfinx-dev (>= 1:0.5.2~), python3-dolfinx,
 python3-all-dev,
 python3-pytest,
 python3-setuptools,
 dh-python,
 pybuild-plugin-pyproject,
 python3-dolfinx-real,
 python3-gmsh <!nocheck>,
 python3-mpi4py,
 python3-numpy,
 python3-petsc4py,
 python3-scipy,
 python3-ufl
Standards-Version: 4.6.2
Homepage: https://github.com/jorgensd/dolfinx_mpc
Vcs-Browser: https://salsa.debian.org/science-team/fenics/dolfinx-mpc
Vcs-Git: https://salsa.debian.org/science-team/fenics/dolfinx-mpc.git

Package: libdolfinx-mpc-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libdolfinx-mpc0.5 (= ${binary:Version}),
 ${misc:Depends},
Description: Multi-point constraints with FEniCS-X
 This library contains an add-on to FEniCSx enabling the possibilities
 of enforce multi-point constraints. This can be used to for instance
 enforce slip conditions strongly, or apply periodic boundaries..

Package: libdolfinx-mpc0.5
Architecture: any
Multi-Arch: same
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: Multi-point constraints with FEniCS-X
 This library contains an add-on to FEniCSx enabling the possibilities
 of enforce multi-point constraints. This can be used to for instance
 enforce slip conditions strongly, or apply periodic boundaries..

Package: python3-dolfinx-mpc
Architecture: any
Depends: libdolfinx-mpc0.5 (= ${binary:Version}),
 python3-dolfinx-real,
 ${python3:Depends},
 ${shlibs:Depends},
 ${misc:Depends},
Description: Multi-point constraints with FEniCS-X
 This library contains an add-on to FEniCSx enabling the possibilities
 of enforce multi-point constraints. This can be used to for instance
 enforce slip conditions strongly, or apply periodic boundaries..

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

include /usr/share/dpkg/default.mk
export DEB_HOST_MULTIARCH

PY3VERS := $(shell py3versions -v --default | tac -s' ')

%:
	dh $@ --with python3 --buildsystem=cmake

execute_before_dh_clean:
	rm -rf .pybuild
	rm -rf python/build
	rm -rf python/dolfinx_mpc.egg-info
	rm -rf python/.pytest_cache

override_dh_auto_configure:
	dh_auto_configure --sourcedir=cpp

execute_after_dh_auto_install:
	LD_LIBRARY_PATH=$(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH) \
	  CMAKE_PREFIX_PATH=$(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/cmake \
	  pybuild --dir=$(CURDIR)/python --name=dolfinx_mpc --disable test

ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
execute_before_dh_python3:
	cd python/tests; \
	for pyver in $(PY3VERS); do \
	  LD_LIBRARY_PATH=$(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH) \
	  PYTHONPATH=$(CURDIR)/debian/python3-dolfinx-mpc/usr/lib/python$${pyver}/dist-packages \
	  XDG_CACHE_HOME=$(CURDIR)/.pybuild/.cache \
	  python$${pyver} -m pytest $(PYTEST_OPTIONS); \
	done
	rm -rf python/tests/__pycache__
endif

=== debian/tests/control ===
Test-Command: python3 -m pytest
Depends: python3-dolfinx-mpc,
 python3,
 python3-pytest,
 python3-dolfinx,
 python3-gmsh,
 python3-mpi4py,
 python3-numpy,
 python3-petsc4py,
 python3-scipy,
 python3-ufl

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*@ARCHIVE_EXT@)%@PACKAGE@-$1%" \
 https://github.com/jorgensd/dolfinx_mpc/tags \
 (?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@

## dolfinx-mpc 0.6.1

=== cpp/CMakeLists.txt ===
#------------------------------------------------------------------------------
# Top level CMakeLists.txt file for DOLFIN
cmake_minimum_required(VERSION 3.19)

#------------------------------------------------------------------------------
# Set project name and version number
project(DOLFINX_MPC VERSION "0.6.1")

#------------------------------------------------------------------------------
# Set CMake options, see `cmake --help-policy CMP000x`

cmake_policy(VERSION 3.19)

#------------------------------------------------------------------------------
# Use C++17
set(CMAKE_CXX_STANDARD 20)

# Require C++17
set(CMAKE_CXX_STANDARD_REQUIRED ON)

# Do not enable compler-specific extensions
set(CMAKE_CXX_EXTENSIONS OFF)

#------------------------------------------------------------------------------
# General configuration
# Make sure CMake uses the correct DOLFINConfig.cmake for tests and demos
set(CMAKE_PREFIX_PATH ${CMAKE_PREFIX_PATH} ${CMAKE_CURRENT_BINARY_DIR}/dolfinx_mpc)

#------------------------------------------------------------------------------
# configurable options for how we want to build

include(FeatureSummary)

option(BUILD_SHARED_LIBS "Build DOLFINX_MPC with shared libraries." ON)
add_feature_info(BUILD_SHARED_LIBS BUILD_SHARED_LIBS "Build DOLFINX_MPC with shared libraries.")

option(CMAKE_INSTALL_RPATH_USE_LINK_PATH "Add paths to linker search and installed rpath." ON)
add_feature_info(CMAKE_INSTALL_RPATH_USE_LINK_PATH CMAKE_INSTALL_RPATH_USE_LINK_PATH "Add paths to linker search and installed rpath.")

# Check for required package DOLFINX
find_package(DOLFINX 0.6.0 REQUIRED)
set_package_properties(DOLFINX PROPERTIES TYPE REQUIRED
    DESCRIPTION "New generation Dynamic Object-oriented Library for - FINite element computation"
    URL "https://github.com/FEniCS/dolfinx"
    PURPOSE "Main dependency of library")
feature_summary(WHAT ALL)


# Installation of DOLFIN_MPC library

# Declare the library (target)

add_library(dolfinx_mpc)

# dolfinx gives us transitive dependency on mpi, petsc, basix, ufcx
# without us needing to reimplement detection/dependency
target_link_libraries(dolfinx_mpc PUBLIC dolfinx)


#------------------------------------------------------------------------------
include(GNUInstallDirs)

#------------------------------------------------------------------------------

install(FILES dolfinx_mpc.h  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/dolfinx_mpc COMPONENT Development)

install(FILES assemble_utils.h mpi_utils.h ContactConstraint.h utils.h MultiPointConstraint.h SlipConstraint.h PeriodicConstraint.h assemble_matrix.h assemble_vector.h lifting.h mpc_helpers.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/dolfinx_mpc COMPONENT Development)
# Add source files to the target
target_sources(dolfinx_mpc PRIVATE
${CMAKE_CURRENT_SOURCE_DIR}/SlipConstraint.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/ContactConstraint.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/PeriodicConstraint.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/utils.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/assemble_matrix.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/assemble_vector.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/mpc_helpers.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/assemble_utils.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/mpi_utils.cpp
  )

# Set target include location (for build and installed)
target_include_directories(dolfinx_mpc PUBLIC
                           $<INSTALL_INTERFACE:include>
                           "$<BUILD_INTERFACE:${DOLFINX_MPC_SOURCE_DIR};${DOLFINX_MPC_SOURCE_DIR}/dolfinx_mpc>")

# Set target properties
set_target_properties(dolfinx_mpc PROPERTIES
  VERSION ${DOLFINX_MPC_VERSION}
  SOVERSION ${DOLFINX_MPC_VERSION_MAJOR}.${DOLFINX_MPC_VERSION_MINOR})


# Add version to definitions (public)
target_compile_definitions(dolfinx_mpc PUBLIC DOLFINX_MPC_VERSION="${DOLFINX_MPC_VERSION}")


#------------------------------------------------------------------------------
# Install dolfinx library and header files
install(TARGETS dolfinx_mpc
  EXPORT DOLFINX_MPCTargets
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR} COMPONENT RuntimeExecutables
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT RuntimeLibraries
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT Development
  )

# Generate DOLFINTargets.cmake
install(EXPORT DOLFINX_MPCTargets DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/dolfinx_mpc)

include(CMakePackageConfigHelpers)

configure_package_config_file(${DOLFINX_MPC_SOURCE_DIR}/DOLFINX_MPCConfig.cmake.in
${CMAKE_BINARY_DIR}/dolfinx_mpc/DOLFINX_MPCConfig.cmake
INSTALL_DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/dolfinx_mpc)

# Install CMake helper files
install(
  FILES
  ${CMAKE_BINARY_DIR}/dolfinx_mpc/DOLFINX_MPCConfig.cmake
  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/dolfinx_mpc
  COMPONENT Development)

#------------------------------------------------------------------------------

=== python/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.10)
+cmake_minimum_required(VERSION 3.19)
 
 PROJECT(dolfinx_mpc_pybind11)
 
@@ -6,7 +6,8 @@
   $ENV{PYBIND11_DIR} $ENV{PYBIND11_ROOT})
 
 find_package(DOLFINX_MPC REQUIRED)
-find_package(Basix REQUIRED)
+MESSAGE(STATUS "Found dolfinx_mpc ${DOLFINX_MPC_VERSION}")
+MESSAGE(STATUS "Found dolfinx ${DOLFINX_VERSION}")
 
 # Set C++ standard before finding pybind11
 set(CMAKE_CXX_STANDARD 20)
@@ -18,9 +19,8 @@
    dolfinx_mpc/mpc.cpp
    dolfinx_mpc/dolfinx_mpc.cpp)
 
-target_link_libraries(cpp PRIVATE pybind11::module dolfinx_mpc)
-target_link_libraries(cpp PUBLIC dolfinx)
-target_include_directories(cpp PUBLIC dolfinx)
+target_link_libraries(cpp PRIVATE pybind11::module)
+target_link_libraries(cpp PUBLIC dolfinx_mpc)
 
 # Get python include-dirs
 execute_process(
@@ -41,14 +41,6 @@
 endif()
 
 
-# Add to CMake search path
-set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR})
-
-# Add DOLFINX libraries and other config
-find_package(DOLFINX REQUIRED)
-if (DOLFINX_FOUND)
-   target_include_directories(cpp PRIVATE ${DOLFINX_INCLUDE_DIR})
-
 # Find petsc4py through python
 execute_process(
   COMMAND ${PYTHON_EXECUTABLE} -c "import petsc4py; print(petsc4py.get_include())"
@@ -58,6 +50,3 @@
   OUTPUT_STRIP_TRAILING_WHITESPACE
   )
 target_include_directories(cpp PRIVATE ${PETSC4PY_INCLUDE_DIR})
-
-endif()
-

=== debian/changelog ===
dolfinx-mpc (0.6.1-3build1) mantic; urgency=medium

  * No-change rebuild with fenics-basix 0.6.0-5 to pick up the new gcc13
    soname. The previous rebuild used 0.6.0-4 for arm64, armhf, ppc64el,
    riscv64, and s390x (basically only amd64 was built with 0.6.0-5).

 -- Andreas Hasenack <andreas@canonical.com>  Tue, 08 Aug 2023 11:07:00 -0300

dolfinx-mpc (0.6.1-3) unstable; urgency=medium

  * rebuild with gcc-13 (with dolfinx patched). Closes: #1037623.

 -- Drew Parsons <dparsons@debian.org>  Sat, 22 Jul 2023 19:30:39 +0200

dolfinx-mpc (0.6.1-2) unstable; urgency=medium

  * push dolfinx-mpc 0.6 to unstable

 -- Drew Parsons <dparsons@debian.org>  Mon, 26 Jun 2023 11:57:49 +0200

dolfinx-mpc (0.6.1-1) experimental; urgency=medium

  * New upstream release (ABI 0.6).
  * drop debian patch cmake_dolfinx_upper_version.patch

 -- Drew Parsons <dparsons@debian.org>  Mon, 30 Jan 2023 17:51:59 +0100

=== debian/control ===
--- 
+++ 
@@ -5,8 +5,8 @@
 Rules-Requires-Root: no
 Build-Depends:
  debhelper-compat (= 13),
- libbasix-dev (>= 0.5.0~), python3-basix,
- libdolfinx-dev (>= 1:0.5.2~), python3-dolfinx,
+ libbasix-dev (>= 0.6.0~), python3-basix,
+ libdolfinx-dev (>= 1:0.6.0~), python3-dolfinx,
  python3-all-dev,
  python3-pytest,
  python3-setuptools,
@@ -29,14 +29,14 @@
 Architecture: any
 Multi-Arch: same
 Depends:
- libdolfinx-mpc0.5 (= ${binary:Version}),
+ libdolfinx-mpc0.6 (= ${binary:Version}),
  ${misc:Depends},
 Description: Multi-point constraints with FEniCS-X
  This library contains an add-on to FEniCSx enabling the possibilities
  of enforce multi-point constraints. This can be used to for instance
  enforce slip conditions strongly, or apply periodic boundaries..
 
-Package: libdolfinx-mpc0.5
+Package: libdolfinx-mpc0.6
 Architecture: any
 Multi-Arch: same
 Depends:
@@ -49,7 +49,7 @@
 
 Package: python3-dolfinx-mpc
 Architecture: any
-Depends: libdolfinx-mpc0.5 (= ${binary:Version}),
+Depends: libdolfinx-mpc0.6 (= ${binary:Version}),
  python3-dolfinx-real,
  ${python3:Depends},
  ${shlibs:Depends},

## dolfinx-mpc 0.8.0.post1

=== cpp/CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 
 #------------------------------------------------------------------------------
 # Set project name and version number
-project(DOLFINX_MPC VERSION "0.6.1")
+project(DOLFINX_MPC VERSION "0.8.0.0")
 
 #------------------------------------------------------------------------------
 # Set CMake options, see `cmake --help-policy CMP000x`
@@ -38,7 +38,7 @@
 add_feature_info(CMAKE_INSTALL_RPATH_USE_LINK_PATH CMAKE_INSTALL_RPATH_USE_LINK_PATH "Add paths to linker search and installed rpath.")
 
 # Check for required package DOLFINX
-find_package(DOLFINX 0.6.0 REQUIRED)
+find_package(DOLFINX 0.8.0.0 REQUIRED)
 set_package_properties(DOLFINX PROPERTIES TYPE REQUIRED
     DESCRIPTION "New generation Dynamic Object-oriented Library for - FINite element computation"
     URL "https://github.com/FEniCS/dolfinx"
@@ -67,13 +67,9 @@
 install(FILES assemble_utils.h mpi_utils.h ContactConstraint.h utils.h MultiPointConstraint.h SlipConstraint.h PeriodicConstraint.h assemble_matrix.h assemble_vector.h lifting.h mpc_helpers.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/dolfinx_mpc COMPONENT Development)
 # Add source files to the target
 target_sources(dolfinx_mpc PRIVATE
-${CMAKE_CURRENT_SOURCE_DIR}/SlipConstraint.cpp
-  ${CMAKE_CURRENT_SOURCE_DIR}/ContactConstraint.cpp
-  ${CMAKE_CURRENT_SOURCE_DIR}/PeriodicConstraint.cpp
   ${CMAKE_CURRENT_SOURCE_DIR}/utils.cpp
   ${CMAKE_CURRENT_SOURCE_DIR}/assemble_matrix.cpp
   ${CMAKE_CURRENT_SOURCE_DIR}/assemble_vector.cpp
-  ${CMAKE_CURRENT_SOURCE_DIR}/mpc_helpers.cpp
   ${CMAKE_CURRENT_SOURCE_DIR}/assemble_utils.cpp
   ${CMAKE_CURRENT_SOURCE_DIR}/mpi_utils.cpp
   )

=== python/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.19)

PROJECT(dolfinx_mpc_pybind11)

# Set C++ standard
set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

find_package(Python COMPONENTS Interpreter Development REQUIRED)

# Detect the installed nanobind package and import it into CMake
execute_process(
  COMMAND "${Python_EXECUTABLE}" -m nanobind --cmake_dir
  OUTPUT_STRIP_TRAILING_WHITESPACE OUTPUT_VARIABLE NB_DIR)
list(APPEND CMAKE_PREFIX_PATH "${NB_DIR}")
find_package(nanobind CONFIG REQUIRED)

execute_process(
  COMMAND
  ${Python3_EXECUTABLE} -c "import os, sys, basix; sys.stdout.write(os.path.dirname(basix.__file__))"
  OUTPUT_VARIABLE BASIX_PY_DIR
  RESULT_VARIABLE BASIX_PY_COMMAND_RESULT
  ERROR_VARIABLE BASIX_ERROR_OUT OUTPUT_STRIP_TRAILING_WHITESPACE
)
find_package(Basix REQUIRED CONFIG HINTS ${BASIX_PY_DIR})
if (Basix_FOUND)
  message(STATUS "Found Basix at ${Basix_DIR}")
endif()
find_package(DOLFINX REQUIRED CONFIG)
if (DOLFINX_FOUND)
  message(STATUS "Found DOLFINx at ${DOLFINX_DIR}")
endif()


# Add DOLFINx_mpc libraries
find_package(DOLFINX_MPC REQUIRED CONFIG)
if (DOLFINX_MPC_FOUND)
  message(STATUS "Found DOLFINx_MPC at ${DOLFINX_MPC_DIR}")
endif()

# Create the binding library nanobind handles its own calls to
# target_link_libraries
nanobind_add_module(
  cpp
  NOMINSIZE
  MODULE
  dolfinx_mpc/dolfinx_mpc.cpp
  dolfinx_mpc/mpc.cpp
)
# Add strict compiler flags
# include(CheckCXXCompilerFlag)
# check_cxx_compiler_flag("-Wall -Werror -pedantic" HAVE_PEDANTIC)

# if(HAVE_PEDANTIC)
#   # target_compile_options(cpp PRIVATE -Wall;-Werror;-pedantic)
# endif()
target_link_libraries(cpp PRIVATE dolfinx_mpc)

# Check for petsc4py
execute_process(
  COMMAND ${Python_EXECUTABLE} -c "import petsc4py; print(petsc4py.get_include())"
  OUTPUT_VARIABLE PETSC4PY_INCLUDE_DIR
  RESULT_VARIABLE PETSC4PY_COMMAND_RESULT
  ERROR_QUIET OUTPUT_STRIP_TRAILING_WHITESPACE
)

if(NOT PETSC4PY_COMMAND_RESULT)
  message(STATUS "Found petsc4py include directory at ${PETSC4PY_INCLUDE_DIR}")
  target_include_directories(cpp PRIVATE ${PETSC4PY_INCLUDE_DIR})
else()
  message(FATAL_ERROR "petsc4py could not be found.")
endif()



# Get python include-dirs
execute_process(
  COMMAND ${Python3_EXECUTABLE} -c "import dolfinx.wrappers, sys; sys.stdout.write(str(dolfinx.wrappers.get_include_path()))"
  OUTPUT_VARIABLE DOLFINX_PY_DIR
  RESULT_VARIABLE DOLFINX_PY_COMMAND_RESULT OUTPUT_STRIP_TRAILING_WHITESPACE)

if (DOLFINX_PY_DIR)
  message(STATUS "Adding ${DOLFINX_PY_DIR} to include directories")
  target_include_directories(cpp PRIVATE ${DOLFINX_PY_DIR})
endif()


set_target_properties(cpp PROPERTIES INSTALL_RPATH_USE_LINK_PATH TRUE)

install(TARGETS cpp DESTINATION dolfinx_mpc)

=== debian/changelog ===
dolfinx-mpc (0.8.0.post1-5) unstable; urgency=medium

  * Rebuild for python3-basix 0.8.0-8 to ensure that nanobind wrappers of
    python3-basix, python3-dolfinx and python3-dolfinx-mpc are all built against
    GCC 14. Closes: #1074920.

 -- Francesco Ballarin <francesco.ballarin@unicatt.it>  Wed, 28 Aug 2024 10:03:47 +0000

dolfinx-mpc (0.8.0.post1-4) unstable; urgency=medium

  * Build-Depends on python3-nanobind (>= 2.0.0~)

 -- Francesco Ballarin <francesco.ballarin@unicatt.it>  Sun, 02 Jun 2024 14:00:25 +0000

dolfinx-mpc (0.8.0.post1-3exp1) experimental; urgency=medium

  * Add debian/patches/b9657064a29bdff0638c7d2f952e85cfe41104df.diff:
    - part of upstream PR #119, guarantees compatibility with nanobind 2.0
  * Fix Maintainer name of Debian Science team (routine-update)
  * Remove trailing whitespace in debian/changelog (routine-update)
  * Build-Depends: s/dh-python/dh-sequence-python3/ (routine-update)
  * Run debci on all available python versions

 -- Francesco Ballarin <francesco.ballarin@unicatt.it>  Sat, 01 Jun 2024 13:05:06 +0000

dolfinx-mpc (0.8.0.post1-2) unstable; urgency=medium

  * Build-Depends on released libbasix-dev and libdolfinx-dev 0.8.0, rather
    than the pre-release git snapshot.

 -- Francesco Ballarin <francesco.ballarin@unicatt.it>  Mon, 06 May 2024 05:28:49 +0000

dolfinx-mpc (0.8.0.post1-1) unstable; urgency=medium

  * New upstream release
    - compatibility with dolfinx 0.8.0
    - post0 and post1 tags are due to bugfixes in the release of the docker
      image, hence 0.8.0.post1 is functionally equivalent to 0.8.0
  * Bump ABI to 0.8 in debian/control

 -- Francesco Ballarin <francesco.ballarin@unicatt.it>  Sat, 04 May 2024 07:57:09 +0000

dolfinx-mpc (0.7.3~git20240414.2e42426-1) experimental; urgency=medium

  * New upstream snapshot.
  * Add Francesco Ballarin to uploaders.
  * Build-Depends on libbasix-dev and libdolfinx-dev from experimental 0.8.0
    pre-release
  * Increase Standards-Version: 4.7.0
  * Refresh patches
  * Add python3-nanobind and python3-scikit-build-core to Build-Depends
  * copy LICENSE to python dir during python module build. Upstream's
    pyproject.toml uses a relative path ../LICENSE, but pybuild copies
    source and builds in tmp, missing the LICENSE file unless it is
    copied there. Use debian/patches/python_local_LICENSE.patch.
  * Update Maintainer: Debian Science Team

 -- Francesco Ballarin <francesco.ballarin@unicatt.it>  Sun, 14 Apr 2024 13:03:01 +0000

dolfinx-mpc (0.7.2-1) unstable; urgency=medium

  * New upstream release.

 -- Drew Parsons <dparsons@debian.org>  Wed, 17 Jan 2024 19:38:18 +0100

dolfinx-mpc (0.7.1-1) unstable; urgency=medium

  * New upstream release.
  * update debian/watch to current best-practice for github.
    Needed to catch "post" versions in downloaded upstream filename.

 -- Drew Parsons <dparsons@debian.org>  Sun, 31 Dec 2023 11:45:15 +0100

dolfinx-mpc (0.7.0.post1-1) unstable; urgency=medium

  * New upstream release patch.
    - applies debian patch include_algorithm.patch

 -- Drew Parsons <dparsons@debian.org>  Wed, 01 Nov 2023 10:24:31 +0100

dolfinx-mpc (0.7.0-1exp1) experimental; urgency=medium

  * New upstream release (ABI 0.7).
    - applies debian patch fix_mesh_py3.11.patch
  * debian patch include_algorithm.patch #includes <algorithm> to
    define std::find. See upstream Issue#80.

 -- Drew Parsons <dparsons@debian.org>  Sun, 29 Oct 2023 23:29:05 +0100

=== debian/control ===
--- 
+++ 
@@ -1,25 +1,29 @@
 Source: dolfinx-mpc
 Section: libs
 Priority: optional
-Maintainer: Drew Parsons <dparsons@debian.org>
+Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Uploaders: Drew Parsons <dparsons@debian.org>,
+           Francesco Ballarin <francesco.ballarin@unicatt.it>
 Rules-Requires-Root: no
 Build-Depends:
  debhelper-compat (= 13),
- libbasix-dev (>= 0.6.0~), python3-basix,
- libdolfinx-dev (>= 1:0.6.0~), python3-dolfinx,
+ libbasix-dev (>= 0.8.0~), python3-basix,
+ libdolfinx-dev (>= 1:0.8.0~), python3-dolfinx,
  python3-all-dev,
  python3-pytest,
  python3-setuptools,
- dh-python,
+ dh-sequence-python3,
  pybuild-plugin-pyproject,
  python3-dolfinx-real,
  python3-gmsh <!nocheck>,
  python3-mpi4py,
+ python3-nanobind (>= 2.0.0~),
  python3-numpy,
  python3-petsc4py,
+ python3-scikit-build-core,
  python3-scipy,
  python3-ufl
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Homepage: https://github.com/jorgensd/dolfinx_mpc
 Vcs-Browser: https://salsa.debian.org/science-team/fenics/dolfinx-mpc
 Vcs-Git: https://salsa.debian.org/science-team/fenics/dolfinx-mpc.git
@@ -29,14 +33,14 @@
 Architecture: any
 Multi-Arch: same
 Depends:
- libdolfinx-mpc0.6 (= ${binary:Version}),
+ libdolfinx-mpc0.8 (= ${binary:Version}),
  ${misc:Depends},
 Description: Multi-point constraints with FEniCS-X
  This library contains an add-on to FEniCSx enabling the possibilities
  of enforce multi-point constraints. This can be used to for instance
  enforce slip conditions strongly, or apply periodic boundaries..
 
-Package: libdolfinx-mpc0.6
+Package: libdolfinx-mpc0.8
 Architecture: any
 Multi-Arch: same
 Depends:
@@ -49,7 +53,7 @@
 
 Package: python3-dolfinx-mpc
 Architecture: any
-Depends: libdolfinx-mpc0.6 (= ${binary:Version}),
+Depends: libdolfinx-mpc0.8 (= ${binary:Version}),
  python3-dolfinx-real,
  ${python3:Depends},
  ${shlibs:Depends},

## dolfinx-mpc 0.9.0

=== debian/changelog ===
dolfinx-mpc (0.9.0-2) unstable; urgency=medium

  * Upload to unstable

 -- Francesco Ballarin <francesco.ballarin@unicatt.it>  Wed, 06 Nov 2024 08:11:25 +0000

dolfinx-mpc (0.9.0-1exp1) experimental; urgency=medium

  * New upstream release 0.9.0:
    - compatible with dolfinx 0.9.0
    - ABI 0.9
  * Refresh
    - cmake_config_libdir.patch
    - tests_no_numba.patch
    - cmake_no_runpath.patch
    - python_local_LICENSE.patch
    to ensure that they apply without fuzz.
  * Drop
    - b9657064a29bdff0638c7d2f952e85cfe41104df.diff
    because the patch was included in the upstream release.

 -- Francesco Ballarin <francesco.ballarin@unicatt.it>  Sun, 03 Nov 2024 13:43:22 +0000

## dolfinx-mpc 0.9.1

=== cpp/CMakeLists.txt ===
--- 
+++ 
@@ -1,25 +1,10 @@
 #------------------------------------------------------------------------------
-# Top level CMakeLists.txt file for DOLFIN
-cmake_minimum_required(VERSION 3.19)
+# Top level CMakeLists.txt file for DOLFINX_MPC
+cmake_minimum_required(VERSION 3.21)
 
 #------------------------------------------------------------------------------
 # Set project name and version number
-project(DOLFINX_MPC VERSION "0.8.0.0")
-
-#------------------------------------------------------------------------------
-# Set CMake options, see `cmake --help-policy CMP000x`
-
-cmake_policy(VERSION 3.19)
-
-#------------------------------------------------------------------------------
-# Use C++17
-set(CMAKE_CXX_STANDARD 20)
-
-# Require C++17
-set(CMAKE_CXX_STANDARD_REQUIRED ON)
-
-# Do not enable compler-specific extensions
-set(CMAKE_CXX_EXTENSIONS OFF)
+project(DOLFINX_MPC VERSION "0.9.0.0")
 
 #------------------------------------------------------------------------------
 # General configuration
@@ -38,7 +23,7 @@
 add_feature_info(CMAKE_INSTALL_RPATH_USE_LINK_PATH CMAKE_INSTALL_RPATH_USE_LINK_PATH "Add paths to linker search and installed rpath.")
 
 # Check for required package DOLFINX
-find_package(DOLFINX 0.8.0.0 REQUIRED)
+find_package(DOLFINX 0.9.0.0 REQUIRED)
 set_package_properties(DOLFINX PROPERTIES TYPE REQUIRED
     DESCRIPTION "New generation Dynamic Object-oriented Library for - FINite element computation"
     URL "https://github.com/FEniCS/dolfinx"
@@ -51,6 +36,7 @@
 # Declare the library (target)
 
 add_library(dolfinx_mpc)
+target_compile_features(dolfinx_mpc PUBLIC cxx_std_20)
 
 # dolfinx gives us transitive dependency on mpi, petsc, basix, ufcx
 # without us needing to reimplement detection/dependency

=== python/demos/Makefile ===
contact3D-serial:
	python3 demo_contact_3D.py --theta 0 --timing
	python3 demo_contact_3D.py --theta 1.05 --timing
	python3 demo_contact_3D.py --gmsh --theta 0 --timing
	python3 demo_contact_3D.py --gmsh --theta 1.05 --timing
	python3 demo_contact_3D.py --gmsh --no-slip --theta 0 --timing
	python3 demo_contact_3D.py --gmsh --no-slip --theta 1.05 --timing
	python3 demo_contact_3D.py --gmsh --no-slip --hex --theta 0 --timing
	python3 demo_contact_3D.py --gmsh --no-slip --hex --theta 1.05 --timing


contact3D-parallel:
	mpirun -n 4 python3 demo_contact_3D.py --theta 0 --timing
	mpirun -n 4 python3 demo_contact_3D.py --theta 1.05 --timing
	mpirun -n 4 python3 demo_contact_3D.py --gmsh --theta 0 --timing
	mpirun -n 4 python3 demo_contact_3D.py --gmsh --theta 1.05 --timing
	mpirun -n 4 python3 demo_contact_3D.py --gmsh --no-slip --theta 0 --timing
	mpirun -n 4 python3 demo_contact_3D.py --gmsh --no-slip --theta 1.05 --timing
	mpirun -n 4 python3 demo_contact_3D.py --gmsh --no-slip --hex --theta 0 --timing
	mpirun -n 4 python3 demo_contact_3D.py --gmsh --no-slip --hex --theta 1.05 --timing

contact2D-serial:
	python3 demo_contact_2D.py --theta 0 --timing
	python3 demo_contact_2D.py --theta 1.05 --timing
	python3 demo_contact_2D.py --gmsh --theta 0 --timing
	python3 demo_contact_2D.py --gmsh --theta 1.05 --timing
	python3 demo_contact_2D.py --quad --gmsh --theta 0 --timing
	python3 demo_contact_2D.py --quad --gmsh --theta 1.05 --timing

contact2D-parallel:
	mpirun -n 4 python3 demo_contact_2D.py --theta 0 --timing
	mpirun -n 4 python3 demo_contact_2D.py --theta 1.05 --timing
	mpirun -n 4 python3 demo_contact_2D.py --gmsh --theta 0 --timing
	mpirun -n 4 python3 demo_contact_2D.py --gmsh --theta 1.05 --timing
	mpirun -n 4 python3 demo_contact_2D.py --quad --gmsh --theta 0 --timing
	mpirun -n 4 python3 demo_contact_2D.py --quad --gmsh --theta 1.05 --timing

=== debian/changelog ===
dolfinx-mpc (0.9.1-2) unstable; urgency=medium

  * debian patch free_MPI_communicator_PR171.patch applies upstream
    PR#171 (release 0.9.2) to free MPI communicators after use

 -- Drew Parsons <dparsons@debian.org>  Wed, 09 Jul 2025 12:33:18 +0200

dolfinx-mpc (0.9.1-1) unstable; urgency=medium

  * New upstream release

 -- Drew Parsons <dparsons@debian.org>  Mon, 10 Mar 2025 21:45:46 +0100

=== debian/control ===
--- 
+++ 
@@ -7,8 +7,8 @@
 Rules-Requires-Root: no
 Build-Depends:
  debhelper-compat (= 13),
- libbasix-dev (>= 0.8.0~), python3-basix,
- libdolfinx-dev (>= 1:0.8.0~), python3-dolfinx,
+ libbasix-dev (>= 0.9.0~), python3-basix,
+ libdolfinx-dev (>= 1:0.9.0~), python3-dolfinx,
  python3-all-dev,
  python3-pytest,
  python3-setuptools,
@@ -33,14 +33,14 @@
 Architecture: any
 Multi-Arch: same
 Depends:
- libdolfinx-mpc0.8 (= ${binary:Version}),
+ libdolfinx-mpc0.9 (= ${binary:Version}),
  ${misc:Depends},
 Description: Multi-point constraints with FEniCS-X
  This library contains an add-on to FEniCSx enabling the possibilities
  of enforce multi-point constraints. This can be used to for instance
  enforce slip conditions strongly, or apply periodic boundaries..
 
-Package: libdolfinx-mpc0.8
+Package: libdolfinx-mpc0.9
 Architecture: any
 Multi-Arch: same
 Depends:
@@ -53,7 +53,7 @@
 
 Package: python3-dolfinx-mpc
 Architecture: any
-Depends: libdolfinx-mpc0.8 (= ${binary:Version}),
+Depends: libdolfinx-mpc0.9 (= ${binary:Version}),
  python3-dolfinx-real,
  ${python3:Depends},
  ${shlibs:Depends},

=== debian/tests/control ===
--- 
+++ 
@@ -1,6 +1,7 @@
-Test-Command: python3 -m pytest
+Tests: run-tests
 Depends: python3-dolfinx-mpc,
  python3,
+ python3-all-dev,
  python3-pytest,
  python3-dolfinx,
  python3-gmsh,

## dolfinx-mpc 0.9.3

=== cpp/CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 
 #------------------------------------------------------------------------------
 # Set project name and version number
-project(DOLFINX_MPC VERSION "0.9.0.0")
+project(DOLFINX_MPC VERSION "0.9.3.0")
 
 #------------------------------------------------------------------------------
 # General configuration

=== python/CMakeLists.txt ===
--- 
+++ 
@@ -1,11 +1,7 @@
-cmake_minimum_required(VERSION 3.19)
+cmake_minimum_required(VERSION 3.21)
 
-PROJECT(dolfinx_mpc_pybind11)
+PROJECT(dolfinx_mpc_nanobind)
 
-# Set C++ standard
-set(CMAKE_CXX_STANDARD 20)
-set(CMAKE_CXX_STANDARD_REQUIRED ON)
-set(CMAKE_CXX_EXTENSIONS OFF)
 
 find_package(Python COMPONENTS Interpreter Development REQUIRED)
 
@@ -48,18 +44,14 @@
   dolfinx_mpc/dolfinx_mpc.cpp
   dolfinx_mpc/mpc.cpp
 )
-# Add strict compiler flags
-# include(CheckCXXCompilerFlag)
-# check_cxx_compiler_flag("-Wall -Werror -pedantic" HAVE_PEDANTIC)
 
-# if(HAVE_PEDANTIC)
-#   # target_compile_options(cpp PRIVATE -Wall;-Werror;-pedantic)
-# endif()
+target_compile_definitions(cpp PRIVATE cxx_std_20)
 target_link_libraries(cpp PRIVATE dolfinx_mpc)
 
 # Check for petsc4py
 execute_process(
-  COMMAND ${Python_EXECUTABLE} -c "import petsc4py; print(petsc4py.get_include())"
+  COMMAND ${Python_EXECUTABLE} -c
+          "import petsc4py; print(petsc4py.get_include())"
   OUTPUT_VARIABLE PETSC4PY_INCLUDE_DIR
   RESULT_VARIABLE PETSC4PY_COMMAND_RESULT
   ERROR_QUIET OUTPUT_STRIP_TRAILING_WHITESPACE
@@ -68,8 +60,9 @@
 if(NOT PETSC4PY_COMMAND_RESULT)
   message(STATUS "Found petsc4py include directory at ${PETSC4PY_INCLUDE_DIR}")
   target_include_directories(cpp PRIVATE ${PETSC4PY_INCLUDE_DIR})
+  target_compile_definitions(cpp PRIVATE HAS_PETSC4PY)
 else()
-  message(FATAL_ERROR "petsc4py could not be found.")
+  message(FATAL_ERROR "petsc4py not found.")
 endif()

=== python/benchmarks/Makefile ===
periodic:
	mpirun -n 23 python3 ref_periodic.py --nref 6 --tet --boomeramg --degree 2
	mpirun -n 23 python3 bench_periodic.py --nref 6 --tet --boomeramg --degree 2
	python3 visualize_iterations.py --periodic

elasticity:
	mpirun -n 23 python3 ref_elasticity.py --nref 6 --gamg --xdmf
	mpirun -n 23 python3 bench_elasticity_edge.py --nref 6 --gamg --xdmf --info
	python3 visualize_iterations.py --elasticity

=== debian/changelog ===
dolfinx-mpc (0.9.3-2) unstable; urgency=medium

  * debian patch python_depends_nanobind.patch adds nanobind to python
    dependencies (pyproject.toml) so dh_python3 catches the nanobind ABI.
    See nanobind transition Bug#1111004. Closes: #1096535.

 -- Drew Parsons <dparsons@debian.org>  Wed, 10 Sep 2025 14:58:49 +0200

dolfinx-mpc (0.9.3-1) unstable; urgency=medium

  * New upstream release
    - applies debian patch free_MPI_communicator_PR171.patch
  * Standards-Version: 4.7.2

 -- Drew Parsons <dparsons@debian.org>  Thu, 28 Aug 2025 12:05:50 +0200

=== debian/control ===
--- 
+++ 
@@ -23,7 +23,7 @@
  python3-scikit-build-core,
  python3-scipy,
  python3-ufl
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Homepage: https://github.com/jorgensd/dolfinx_mpc
 Vcs-Browser: https://salsa.debian.org/science-team/fenics/dolfinx-mpc
 Vcs-Git: https://salsa.debian.org/science-team/fenics/dolfinx-mpc.git

=== debian/rules ===
--- 
+++ 
@@ -9,18 +9,20 @@
 PY3VERS := $(shell py3versions -v --default | tac -s' ')
 
 %:
-	dh $@ --with python3 --buildsystem=cmake
+	dh $@ --buildsystem=cmake
 
 execute_before_dh_clean:
 	rm -rf .pybuild
 	rm -rf python/build
 	rm -rf python/dolfinx_mpc.egg-info
+	rm -rf python/LICENSE
 	rm -rf python/.pytest_cache
 
 override_dh_auto_configure:
 	dh_auto_configure --sourcedir=cpp
 
 execute_after_dh_auto_install:
+	cp LICENSE python
 	LD_LIBRARY_PATH=$(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH) \
 	  CMAKE_PREFIX_PATH=$(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/cmake \
 	  pybuild --dir=$(CURDIR)/python --name=dolfinx_mpc --disable test

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?@ANY_VERSION@(@ARCHIVE_EXT@)%@PACKAGE@-$1$2%" \
 https://github.com/jorgensd/dolfinx_mpc/tags \
 (?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@

## dolfinx-mpc 0.10.0

=== cpp/CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,7 @@
 
 #------------------------------------------------------------------------------
 # Set project name and version number
-project(DOLFINX_MPC VERSION "0.9.3.0")
+project(DOLFINX_MPC VERSION "0.10.0")
 
 #------------------------------------------------------------------------------
 # General configuration
@@ -23,7 +23,7 @@
 add_feature_info(CMAKE_INSTALL_RPATH_USE_LINK_PATH CMAKE_INSTALL_RPATH_USE_LINK_PATH "Add paths to linker search and installed rpath.")
 
 # Check for required package DOLFINX
-find_package(DOLFINX 0.9.0.0 REQUIRED)
+find_package(DOLFINX 0.10.0.0 REQUIRED)
 set_package_properties(DOLFINX PROPERTIES TYPE REQUIRED
     DESCRIPTION "New generation Dynamic Object-oriented Library for - FINite element computation"
     URL "https://github.com/FEniCS/dolfinx"

=== python/CMakeLists.txt ===
--- 
+++ 
@@ -41,8 +41,8 @@
   cpp
   NOMINSIZE
   MODULE
-  dolfinx_mpc/dolfinx_mpc.cpp
-  dolfinx_mpc/mpc.cpp
+  src/dolfinx_mpc/dolfinx_mpc.cpp
+  src/dolfinx_mpc/mpc.cpp
 )
 
 target_compile_definitions(cpp PRIVATE cxx_std_20)
@@ -69,7 +69,7 @@
 
 # Get python include-dirs
 execute_process(
-  COMMAND ${Python3_EXECUTABLE} -c "import dolfinx.wrappers, sys; sys.stdout.write(str(dolfinx.wrappers.get_include_path()))"
+  COMMAND ${Python3_EXECUTABLE} -c "import dolfinx, sys; sys.stdout.write(str(dolfinx.get_include()))"
   OUTPUT_VARIABLE DOLFINX_PY_DIR
   RESULT_VARIABLE DOLFINX_PY_COMMAND_RESULT OUTPUT_STRIP_TRAILING_WHITESPACE)

=== debian/changelog ===
dolfinx-mpc (0.10.0-1exp1) experimental; urgency=medium

  * New upstream release. New ABI 0.10.
    - deprecates debian patch python_local_LICENSE.patch

 -- Drew Parsons <dparsons@debian.org>  Thu, 13 Nov 2025 14:54:07 +0100

=== debian/control ===
--- 
+++ 
@@ -7,8 +7,8 @@
 Rules-Requires-Root: no
 Build-Depends:
  debhelper-compat (= 13),
- libbasix-dev (>= 0.9.0~), python3-basix,
- libdolfinx-dev (>= 1:0.9.0~), python3-dolfinx,
+ libbasix-dev (>= 0.10.0~), python3-basix,
+ libdolfinx-dev (>= 1:0.10.0~), python3-dolfinx,
  python3-all-dev,
  python3-pytest,
  python3-setuptools,
@@ -33,14 +33,14 @@
 Architecture: any
 Multi-Arch: same
 Depends:
- libdolfinx-mpc0.9 (= ${binary:Version}),
+ libdolfinx-mpc0.10 (= ${binary:Version}),
  ${misc:Depends},
 Description: Multi-point constraints with FEniCS-X
  This library contains an add-on to FEniCSx enabling the possibilities
  of enforce multi-point constraints. This can be used to for instance
  enforce slip conditions strongly, or apply periodic boundaries..
 
-Package: libdolfinx-mpc0.9
+Package: libdolfinx-mpc0.10
 Architecture: any
 Multi-Arch: same
 Depends:
@@ -53,7 +53,7 @@
 
 Package: python3-dolfinx-mpc
 Architecture: any
-Depends: libdolfinx-mpc0.9 (= ${binary:Version}),
+Depends: libdolfinx-mpc0.10 (= ${binary:Version}),
  python3-dolfinx-real,
  ${python3:Depends},
  ${shlibs:Depends},
